import { ServiceFactory, ServiceRef } from '@backstage/backend-plugin-api';
export declare class ServiceRegistry {
    #private;
    static create(factories: Array<ServiceFactory>): ServiceRegistry;
    private constructor();
    checkForCircularDeps(): void;
    hasBeenAdded(ref: ServiceRef<any>): boolean;
    add(factory: ServiceFactory): void;
    initializeEagerServicesWithScope(scope: 'root' | 'plugin', pluginId?: string): Promise<void>;
    get<T, TInstances extends 'singleton' | 'multiton'>(ref: ServiceRef<T, 'plugin' | 'root', TInstances>, pluginId: string): Promise<TInstances extends 'multiton' ? T[] : T> | undefined;
}
